
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Usage_eventsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const usage_events = await db.usage_events.create(
            {
                id: data.id || undefined,
        
        event_type: data.event_type
        ||
        null
            ,
            
        input_tokens: data.input_tokens
        ||
        null
            ,
            
        output_tokens: data.output_tokens
        ||
        null
            ,
            
        cost: data.cost
        ||
        null
            ,
            
        occurred_at: data.occurred_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await usage_events.setWorkspace( data.workspace || null, {
            transaction,
        });
        
        await usage_events.setUser( data.user || null, {
            transaction,
        });
        
        await usage_events.setModel( data.model || null, {
            transaction,
        });
        
        await usage_events.setConversation( data.conversation || null, {
            transaction,
        });
        
        await usage_events.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return usage_events;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const usage_eventsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                event_type: item.event_type
            ||
            null
            ,
            
                input_tokens: item.input_tokens
            ||
            null
            ,
            
                output_tokens: item.output_tokens
            ||
            null
            ,
            
                cost: item.cost
            ||
            null
            ,
            
                occurred_at: item.occurred_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const usage_events = await db.usage_events.bulkCreate(usage_eventsData, { transaction });

        // For each item created, replace relation files
        

        return usage_events;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const usage_events = await db.usage_events.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.event_type !== undefined) updatePayload.event_type = data.event_type;
        
        
        if (data.input_tokens !== undefined) updatePayload.input_tokens = data.input_tokens;
        
        
        if (data.output_tokens !== undefined) updatePayload.output_tokens = data.output_tokens;
        
        
        if (data.cost !== undefined) updatePayload.cost = data.cost;
        
        
        if (data.occurred_at !== undefined) updatePayload.occurred_at = data.occurred_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await usage_events.update(updatePayload, {transaction});

        
        
        if (data.workspace !== undefined) {
            await usage_events.setWorkspace(
              
              data.workspace,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await usage_events.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.model !== undefined) {
            await usage_events.setModel(
              
              data.model,
              
              { transaction }
            );
        }
        
        if (data.conversation !== undefined) {
            await usage_events.setConversation(
              
              data.conversation,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await usage_events.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return usage_events;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const usage_events = await db.usage_events.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of usage_events) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of usage_events) {
                await record.destroy({transaction});
            }
        });


        return usage_events;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const usage_events = await db.usage_events.findByPk(id, options);

        await usage_events.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await usage_events.destroy({
            transaction
        });

        return usage_events;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const usage_events = await db.usage_events.findOne(
            { where },
            { transaction },
        );

        if (!usage_events) {
            return usage_events;
        }

        const output = usage_events.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.workspace = await usage_events.getWorkspace({
            transaction
        });
        
        
        output.user = await usage_events.getUser({
            transaction
        });
        
        
        output.model = await usage_events.getModel({
            transaction
        });
        
        
        output.conversation = await usage_events.getConversation({
            transaction
        });
        
        
        output.organizations = await usage_events.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.workspaces,
        as: 'workspace',
        
        where: filter.workspace ? {
          [Op.or]: [
            { id: { [Op.in]: filter.workspace.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.workspace.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.ai_models,
        as: 'model',
        
        where: filter.model ? {
          [Op.or]: [
            { id: { [Op.in]: filter.model.split('|').map(term => Utils.uuid(term)) } },
            {
              display_name: {
                [Op.or]: filter.model.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.conversations,
        as: 'conversation',
        
        where: filter.conversation ? {
          [Op.or]: [
            { id: { [Op.in]: filter.conversation.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.conversation.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            occurred_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    occurred_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.input_tokensRange) {
                const [start, end] = filter.input_tokensRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    input_tokens: {
                    ...where.input_tokens,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    input_tokens: {
                    ...where.input_tokens,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.output_tokensRange) {
                const [start, end] = filter.output_tokensRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    output_tokens: {
                    ...where.output_tokens,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    output_tokens: {
                    ...where.output_tokens,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.costRange) {
                const [start, end] = filter.costRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    cost: {
                    ...where.cost,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    cost: {
                    ...where.cost,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.occurred_atRange) {
                const [start, end] = filter.occurred_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    occurred_at: {
                    ...where.occurred_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    occurred_at: {
                    ...where.occurred_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.event_type) {
                where = {
                    ...where,
                event_type: filter.event_type,
            };
            }
            


      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.usage_events.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'usage_events',
                        'event_type',
                        query,
                    ),
                ],
            };
        }

        const records = await db.usage_events.findAll({
            attributes: [ 'id', 'event_type' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['event_type', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.event_type,
        }));
    }

    
};

